Bug 226806

Summary: Add lock for static cursorMap in MemoryCursor
Product: WebKit Reporter: Sihui Liu <sihui_liu>
Component: WebCore Misc.Assignee: Sihui Liu <sihui_liu>
Status: RESOLVED FIXED    
Severity: Normal CC: alecflett, beidson, cdumez, ews-watchlist, jsbell, webkit-bug-importer
Priority: P2 Keywords: InRadar
Version: WebKit Nightly Build   
Hardware: Unspecified   
OS: Unspecified   
Attachments:
Description Flags
Patch
none
Patch for landing none

Description Sihui Liu 2021-06-08 23:38:41 PDT
...
Comment 1 Sihui Liu 2021-06-08 23:41:47 PDT
Crash on bots shows two workqueues access the cursorMap at the same time:

Thread 16:: Dispatch queue: com.apple.WebKit.IndexedDBServer
0   dyld                          	0x0000000102814d90 ImageLoaderMachO::findClosestSymbol(mach_header const*, void const*, void const**) + 376
1   dyld                          	0x0000000102814c98 ImageLoaderMachO::findClosestSymbol(mach_header const*, void const*, void const**) + 128
2   dyld                          	0x000000010280663c dladdr + 184
3   libdyld.dylib                 	0x000000019b21f42c dladdr + 168
4   com.apple.JavaScriptCore      	0x0000000138087108 WTF::StackTrace::demangle(void*) + 48 (StackTrace.cpp:95)
5   com.apple.JavaScriptCore      	0x00000001380872e8 WTF::StackTrace::dump(WTF::PrintStream&, char const*) const + 140 (StackTrace.cpp:137)
6   com.apple.JavaScriptCore      	0x0000000137fcbadc void WTF::printInternal<WTF::StackTrace>(WTF::PrintStream&, WTF::StackTrace const&) + 40 (PrintStream.h:129)
7   com.apple.JavaScriptCore      	0x0000000139d80aa8 void WTF::PrintStream::printImpl<WTF::StackTrace>(WTF::StackTrace const&) + 40
8   com.apple.JavaScriptCore      	0x0000000139d80a74 void WTF::PrintStream::print<WTF::StackTrace>(WTF::StackTrace const&)::'lambda'(WTF::PrintStream&)::operator()(WTF::PrintStream&) const + 36
9   com.apple.JavaScriptCore      	0x0000000139d80a30 void WTF::PrintStream::atomically<void WTF::PrintStream::print<WTF::StackTrace>(WTF::StackTrace const&)::'lambda'(WTF::PrintStream&)>(WTF::StackTrace const&) + 72
10  com.apple.JavaScriptCore      	0x0000000137fc7f34 void WTF::PrintStream::print<WTF::StackTrace>(WTF::StackTrace const&) + 40 (PrintStream.h:70)
11  com.apple.JavaScriptCore      	0x0000000137fc7dc8 WTFPrintBacktraceWithPrefix + 84 (Assertions.cpp:306)
12  com.apple.JavaScriptCore      	0x0000000137fc7e80 WTFPrintBacktrace + 40 (Assertions.cpp:311)
13  com.apple.JavaScriptCore      	0x0000000137fc7e2c WTFReportBacktrace + 80 (Assertions.cpp:299)
14  com.apple.JavaScriptCore      	0x0000000137fc7f80 WTFCrash + 12 (Assertions.cpp:317)
15  com.apple.WebCore             	0x0000000116127710 WTFCrashWithInfo(int, char const*, char const*, int) + 32
16  com.apple.WebCore             	0x0000000117c51248 WTF::HashTableConstIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::checkValidity(WTF::HashTableConstIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> > const&) const + 116
17  com.apple.WebCore             	0x0000000117c511a8 WTF::HashTableConstIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::operator==(WTF::HashTableConstIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> > const&) const + 40
18  com.apple.WebCore             	0x0000000117c510a0 WTF::HashTableIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::operator==(WTF::HashTableIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> > const&) const + 32
19  com.apple.WebCore             	0x0000000117c50f70 WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::remove(WTF::HashTableIteratorAdapter<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >) + 76
20  com.apple.WebCore             	0x0000000117c07678 WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::remove(WebCore::IDBResourceIdentifier const&) + 80
21  com.apple.WebCore             	0x0000000117c07604 WebCore::IDBServer::MemoryCursor::~MemoryCursor() + 220
22  com.apple.WebCore             	0x0000000117cafafc WebCore::IDBServer::MemoryObjectStoreCursor::~MemoryObjectStoreCursor() + 76
23  com.apple.WebCore             	0x0000000117c9f700 WebCore::IDBServer::MemoryObjectStoreCursor::~MemoryObjectStoreCursor() + 32
24  com.apple.WebCore             	0x0000000117c9f734 WebCore::IDBServer::MemoryObjectStoreCursor::~MemoryObjectStoreCursor() + 32
25  com.apple.WebCore             	0x0000000117cca3f4 std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor>::operator()(WebCore::IDBServer::MemoryObjectStoreCursor*) const + 52
26  com.apple.WebCore             	0x0000000117cca3b4 std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >::reset(WebCore::IDBServer::MemoryObjectStoreCursor*) + 92
27  com.apple.WebCore             	0x0000000117cca428 std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >::~unique_ptr() + 40
28  com.apple.WebCore             	0x0000000117c81aa0 std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >::~unique_ptr() + 32
29  com.apple.WebCore             	0x0000000117ca4e58 WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >::~KeyValuePair() + 36
30  com.apple.WebCore             	0x0000000117ca4e0c WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >::~KeyValuePair() + 32
31  com.apple.WebCore             	0x0000000117ca4d94 WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > > >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::deallocateTable(WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >*) + 108
32  com.apple.WebCore             	0x0000000117ca4c64 WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > > >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::~HashTable() + 60
33  com.apple.WebCore             	0x0000000117ca4c14 WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > > >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::~HashTable() + 32
34  com.apple.WebCore             	0x0000000117ca4be0 WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::~HashMap() + 32
35  com.apple.WebCore             	0x0000000117c7e9d4 WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::~HashMap() + 32
36  com.apple.WebCore             	0x0000000117c7e944 WebCore::IDBServer::MemoryObjectStore::~MemoryObjectStore() + 40
37  com.apple.WebCore             	0x0000000117c7ead8 WebCore::IDBServer::MemoryObjectStore::~MemoryObjectStore() + 32
38  com.apple.WebCore             	0x0000000117c357e0 std::__1::default_delete<WebCore::IDBServer::MemoryObjectStore>::operator()(WebCore::IDBServer::MemoryObjectStore*) const + 40
39  com.apple.WebCore             	0x0000000117c357ac WTF::RefCounted<WebCore::IDBServer::MemoryObjectStore, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStore> >::deref() const + 52
40  com.apple.WebCore             	0x0000000117c3576c WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore>::derefIfNotNull(WebCore::IDBServer::MemoryObjectStore*) + 56
41  com.apple.WebCore             	0x0000000117c35724 WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >::~RefPtr() + 48
42  com.apple.WebCore             	0x0000000117c038fc WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >::~RefPtr() + 32
43  com.apple.WebCore             	0x0000000117ca043c WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >::~KeyValuePair() + 36
44  com.apple.WebCore             	0x0000000117ca03f0 WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >::~KeyValuePair() + 32
45  com.apple.WebCore             	0x0000000117ca0374 WTF::HashTable<unsigned long long, WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > > >, WTF::DefaultHash<unsigned long long>, WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<unsigned long long> >::deallocateTable(WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >*) + 92
46  com.apple.WebCore             	0x0000000117ca0254 WTF::HashTable<unsigned long long, WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > > >, WTF::DefaultHash<unsigned long long>, WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<unsigned long long> >::~HashTable() + 60
47  com.apple.WebCore             	0x0000000117ca0204 WTF::HashTable<unsigned long long, WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > > >, WTF::DefaultHash<unsigned long long>, WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<unsigned long long> >::~HashTable() + 32
48  com.apple.WebCore             	0x0000000117ca01d0 WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::~HashMap() + 32
49  com.apple.WebCore             	0x0000000117c74cc8 WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::~HashMap() + 32
50  com.apple.WebCore             	0x0000000117c74c24 WebCore::IDBServer::MemoryIDBBackingStore::~MemoryIDBBackingStore() + 64
51  com.apple.WebCore             	0x0000000117c74dec WebCore::IDBServer::MemoryIDBBackingStore::~MemoryIDBBackingStore() + 32
52  com.apple.WebCore             	0x0000000117c74e20 WebCore::IDBServer::MemoryIDBBackingStore::~MemoryIDBBackingStore() + 32
53  com.apple.WebCore             	0x0000000117d10614 std::__1::default_delete<WebCore::IDBServer::IDBBackingStore>::operator()(WebCore::IDBServer::IDBBackingStore*) const + 52
54  com.apple.WebCore             	0x0000000117d1058c std::__1::unique_ptr<WebCore::IDBServer::IDBBackingStore, std::__1::default_delete<WebCore::IDBServer::IDBBackingStore> >::reset(WebCore::IDBServer::IDBBackingStore*) + 92
55  com.apple.WebCore             	0x0000000117cf6e9c std::__1::unique_ptr<WebCore::IDBServer::IDBBackingStore, std::__1::default_delete<WebCore::IDBServer::IDBBackingStore> >::operator=(std::nullptr_t) + 44
56  com.apple.WebCore             	0x0000000117d00644 WebCore::IDBServer::UniqueIDBDatabase::close() + 108
57  com.apple.WebCore             	0x0000000117d00254 WebCore::IDBServer::UniqueIDBDatabase::immediateClose() + 972
58  com.apple.WebCore             	0x0000000117bf92d4 WebCore::IDBServer::IDBServer::~IDBServer() + 256
59  com.apple.WebCore             	0x0000000117bf973c WebCore::IDBServer::IDBServer::~IDBServer() + 32
60  com.apple.WebKit              	0x0000000103a1b054 std::__1::default_delete<WebCore::IDBServer::IDBServer>::operator()(WebCore::IDBServer::IDBServer*) const + 40
61  com.apple.WebKit              	0x0000000103a1afd8 std::__1::unique_ptr<WebCore::IDBServer::IDBServer, std::__1::default_delete<WebCore::IDBServer::IDBServer> >::reset(WebCore::IDBServer::IDBServer*) + 92
62  com.apple.WebKit              	0x0000000103a26d14 std::__1::unique_ptr<WebCore::IDBServer::IDBServer, std::__1::default_delete<WebCore::IDBServer::IDBServer> >::operator=(std::nullptr_t) + 44
63  com.apple.WebKit              	0x0000000103a26c1c WebKit::WebIDBServer::close(WTF::CompletionHandler<void ()>&&)::$_8::operator()() + 92
64  com.apple.WebKit              	0x0000000103a26ad8 WTF::Detail::CallableWrapper<WebKit::WebIDBServer::close(WTF::CompletionHandler<void ()>&&)::$_8, void>::call() + 28
65  com.apple.JavaScriptCore      	0x0000000137ff1914 WTF::Function<void ()>::operator()() const + 124 (Function.h:82)
66  com.apple.JavaScriptCore      	0x000000013811827c WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0::operator()() const + 28 (WorkQueueCocoa.cpp:37)
67  com.apple.JavaScriptCore      	0x00000001381184c0 WTF::BlockPtr<void ()> WTF::BlockPtr<void ()>::fromCallable<WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0>(WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0)::'lambda'(void*)::operator()(void*) const + 32 (BlockPtr.h:111)
68  com.apple.JavaScriptCore      	0x0000000138118494 WTF::BlockPtr<void ()> WTF::BlockPtr<void ()>::fromCallable<WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0>(WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0)::'lambda'(void*)::__invoke(void*) + 28 (BlockPtr.h:110)
69  libdispatch.dylib             	0x000000019b0578bc _dispatch_call_block_and_release + 32
70  libdispatch.dylib             	0x000000019b059420 _dispatch_client_callout + 20
71  libdispatch.dylib             	0x000000019b06077c _dispatch_lane_serial_drain + 580
72  libdispatch.dylib             	0x000000019b0612cc _dispatch_lane_invoke + 408
73  libdispatch.dylib             	0x000000019b06b3fc _dispatch_workloop_worker_thread + 708
74  libsystem_pthread.dylib       	0x000000019b202060 _pthread_wqthread + 276
75  libsystem_pthread.dylib       	0x000000019b200d94 start_wqthread + 8

Thread 20 Crashed:: Dispatch queue: com.apple.WebKit.IndexedDBServer
0   com.apple.WebCore             	0x0000000117c17d70 void WTF::removeIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >(WTF::HashTableConstIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >*) + 524
1   com.apple.WebCore             	0x0000000117c17c40 void WTF::removeIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >(WTF::HashTableConstIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >*) + 220
2   com.apple.WebCore             	0x0000000117c17b54 WTF::HashTableConstIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::~HashTableConstIterator() + 32
3   com.apple.WebCore             	0x0000000117c17b20 WTF::HashTableConstIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::~HashTableConstIterator() + 32
4   com.apple.WebCore             	0x0000000117c17aec WTF::HashTableIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::~HashTableIterator() + 32
5   com.apple.WebCore             	0x0000000117c17ab8 WTF::HashTableIterator<WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >, WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*>, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::~HashTableIterator() + 32
6   com.apple.WebCore             	0x0000000117c51040 WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::find(WebCore::IDBResourceIdentifier const&) + 76
7   com.apple.WebCore             	0x0000000117c0766c WTF::HashMap<WebCore::IDBResourceIdentifier, WebCore::IDBServer::MemoryCursor*, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBServer::MemoryCursor*>, WTF::HashTableTraits>::remove(WebCore::IDBResourceIdentifier const&) + 68
8   com.apple.WebCore             	0x0000000117c07604 WebCore::IDBServer::MemoryCursor::~MemoryCursor() + 220
9   com.apple.WebCore             	0x0000000117cafafc WebCore::IDBServer::MemoryObjectStoreCursor::~MemoryObjectStoreCursor() + 76
10  com.apple.WebCore             	0x0000000117c9f700 WebCore::IDBServer::MemoryObjectStoreCursor::~MemoryObjectStoreCursor() + 32
11  com.apple.WebCore             	0x0000000117c9f734 WebCore::IDBServer::MemoryObjectStoreCursor::~MemoryObjectStoreCursor() + 32
12  com.apple.WebCore             	0x0000000117cca3f4 std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor>::operator()(WebCore::IDBServer::MemoryObjectStoreCursor*) const + 52
13  com.apple.WebCore             	0x0000000117cca3b4 std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >::reset(WebCore::IDBServer::MemoryObjectStoreCursor*) + 92
14  com.apple.WebCore             	0x0000000117cca428 std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >::~unique_ptr() + 40
15  com.apple.WebCore             	0x0000000117c81aa0 std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >::~unique_ptr() + 32
16  com.apple.WebCore             	0x0000000117ca4e58 WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >::~KeyValuePair() + 36
17  com.apple.WebCore             	0x0000000117ca4e0c WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >::~KeyValuePair() + 32
18  com.apple.WebCore             	0x0000000117ca4d94 WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > > >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::deallocateTable(WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >*) + 108
19  com.apple.WebCore             	0x0000000117ca4c64 WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > > >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::~HashTable() + 60
20  com.apple.WebCore             	0x0000000117ca4c14 WTF::HashTable<WebCore::IDBResourceIdentifier, WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > > >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<WebCore::IDBResourceIdentifier> >::~HashTable() + 32
21  com.apple.WebCore             	0x0000000117ca4be0 WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::~HashMap() + 32
22  com.apple.WebCore             	0x0000000117c7e9d4 WTF::HashMap<WebCore::IDBResourceIdentifier, std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> >, WTF::DefaultHash<WebCore::IDBResourceIdentifier>, WTF::HashTraits<WebCore::IDBResourceIdentifier>, WTF::HashTraits<std::__1::unique_ptr<WebCore::IDBServer::MemoryObjectStoreCursor, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStoreCursor> > >, WTF::HashTableTraits>::~HashMap() + 32
23  com.apple.WebCore             	0x0000000117c7e944 WebCore::IDBServer::MemoryObjectStore::~MemoryObjectStore() + 40
24  com.apple.WebCore             	0x0000000117c7ead8 WebCore::IDBServer::MemoryObjectStore::~MemoryObjectStore() + 32
25  com.apple.WebCore             	0x0000000117c357e0 std::__1::default_delete<WebCore::IDBServer::MemoryObjectStore>::operator()(WebCore::IDBServer::MemoryObjectStore*) const + 40
26  com.apple.WebCore             	0x0000000117c357ac WTF::RefCounted<WebCore::IDBServer::MemoryObjectStore, std::__1::default_delete<WebCore::IDBServer::MemoryObjectStore> >::deref() const + 52
27  com.apple.WebCore             	0x0000000117c3576c WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore>::derefIfNotNull(WebCore::IDBServer::MemoryObjectStore*) + 56
28  com.apple.WebCore             	0x0000000117c35724 WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >::~RefPtr() + 48
29  com.apple.WebCore             	0x0000000117c038fc WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >::~RefPtr() + 32
30  com.apple.WebCore             	0x0000000117ca043c WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >::~KeyValuePair() + 36
31  com.apple.WebCore             	0x0000000117ca03f0 WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >::~KeyValuePair() + 32
32  com.apple.WebCore             	0x0000000117ca0374 WTF::HashTable<unsigned long long, WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > > >, WTF::DefaultHash<unsigned long long>, WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<unsigned long long> >::deallocateTable(WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >*) + 92
33  com.apple.WebCore             	0x0000000117ca0254 WTF::HashTable<unsigned long long, WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > > >, WTF::DefaultHash<unsigned long long>, WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<unsigned long long> >::~HashTable() + 60
34  com.apple.WebCore             	0x0000000117ca0204 WTF::HashTable<unsigned long long, WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::KeyValuePairKeyExtractor<WTF::KeyValuePair<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > > >, WTF::DefaultHash<unsigned long long>, WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::KeyValuePairTraits, WTF::HashTraits<unsigned long long> >::~HashTable() + 32
35  com.apple.WebCore             	0x0000000117ca01d0 WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::~HashMap() + 32
36  com.apple.WebCore             	0x0000000117c74cc8 WTF::HashMap<unsigned long long, WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> >, WTF::DefaultHash<unsigned long long>, WTF::HashTraits<unsigned long long>, WTF::HashTraits<WTF::RefPtr<WebCore::IDBServer::MemoryObjectStore, WTF::RawPtrTraits<WebCore::IDBServer::MemoryObjectStore>, WTF::DefaultRefDerefTraits<WebCore::IDBServer::MemoryObjectStore> > >, WTF::HashTableTraits>::~HashMap() + 32
37  com.apple.WebCore             	0x0000000117c74c24 WebCore::IDBServer::MemoryIDBBackingStore::~MemoryIDBBackingStore() + 64
38  com.apple.WebCore             	0x0000000117c74dec WebCore::IDBServer::MemoryIDBBackingStore::~MemoryIDBBackingStore() + 32
39  com.apple.WebCore             	0x0000000117c74e20 WebCore::IDBServer::MemoryIDBBackingStore::~MemoryIDBBackingStore() + 32
40  com.apple.WebCore             	0x0000000117d10614 std::__1::default_delete<WebCore::IDBServer::IDBBackingStore>::operator()(WebCore::IDBServer::IDBBackingStore*) const + 52
41  com.apple.WebCore             	0x0000000117d1058c std::__1::unique_ptr<WebCore::IDBServer::IDBBackingStore, std::__1::default_delete<WebCore::IDBServer::IDBBackingStore> >::reset(WebCore::IDBServer::IDBBackingStore*) + 92
42  com.apple.WebCore             	0x0000000117cf6e9c std::__1::unique_ptr<WebCore::IDBServer::IDBBackingStore, std::__1::default_delete<WebCore::IDBServer::IDBBackingStore> >::operator=(std::nullptr_t) + 44
43  com.apple.WebCore             	0x0000000117d00644 WebCore::IDBServer::UniqueIDBDatabase::close() + 108
44  com.apple.WebCore             	0x0000000117d00254 WebCore::IDBServer::UniqueIDBDatabase::immediateClose() + 972
45  com.apple.WebCore             	0x0000000117bf92d4 WebCore::IDBServer::IDBServer::~IDBServer() + 256
46  com.apple.WebCore             	0x0000000117bf973c WebCore::IDBServer::IDBServer::~IDBServer() + 32
47  com.apple.WebKit              	0x0000000103a1b054 std::__1::default_delete<WebCore::IDBServer::IDBServer>::operator()(WebCore::IDBServer::IDBServer*) const + 40
48  com.apple.WebKit              	0x0000000103a1afd8 std::__1::unique_ptr<WebCore::IDBServer::IDBServer, std::__1::default_delete<WebCore::IDBServer::IDBServer> >::reset(WebCore::IDBServer::IDBServer*) + 92
49  com.apple.WebKit              	0x0000000103a26d14 std::__1::unique_ptr<WebCore::IDBServer::IDBServer, std::__1::default_delete<WebCore::IDBServer::IDBServer> >::operator=(std::nullptr_t) + 44
50  com.apple.WebKit              	0x0000000103a26c1c WebKit::WebIDBServer::close(WTF::CompletionHandler<void ()>&&)::$_8::operator()() + 92
51  com.apple.WebKit              	0x0000000103a26ad8 WTF::Detail::CallableWrapper<WebKit::WebIDBServer::close(WTF::CompletionHandler<void ()>&&)::$_8, void>::call() + 28
52  com.apple.JavaScriptCore      	0x0000000137ff1914 WTF::Function<void ()>::operator()() const + 124 (Function.h:82)
53  com.apple.JavaScriptCore      	0x000000013811827c WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0::operator()() const + 28 (WorkQueueCocoa.cpp:37)
54  com.apple.JavaScriptCore      	0x00000001381184c0 WTF::BlockPtr<void ()> WTF::BlockPtr<void ()>::fromCallable<WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0>(WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0)::'lambda'(void*)::operator()(void*) const + 32 (BlockPtr.h:111)
55  com.apple.JavaScriptCore      	0x0000000138118494 WTF::BlockPtr<void ()> WTF::BlockPtr<void ()>::fromCallable<WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0>(WTF::WorkQueue::dispatch(WTF::Function<void ()>&&)::$_0)::'lambda'(void*)::__invoke(void*) + 28 (BlockPtr.h:110)
56  libdispatch.dylib             	0x000000019b0578bc _dispatch_call_block_and_release + 32
57  libdispatch.dylib             	0x000000019b059420 _dispatch_client_callout + 20
58  libdispatch.dylib             	0x000000019b06077c _dispatch_lane_serial_drain + 580
59  libdispatch.dylib             	0x000000019b0612cc _dispatch_lane_invoke + 408
60  libdispatch.dylib             	0x000000019b06b3fc _dispatch_workloop_worker_thread + 708
61  libsystem_pthread.dylib       	0x000000019b202060 _pthread_wqthread + 276
62  libsystem_pthread.dylib       	0x000000019b200d94 start_wqthread + 8
Comment 2 Sihui Liu 2021-06-08 23:43:11 PDT
Created attachment 430942 [details]
Patch
Comment 3 Chris Dumez 2021-06-11 19:36:29 PDT
Comment on attachment 430942 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=430942&action=review

r=me with changes

> Source/WebCore/Modules/indexeddb/server/MemoryCursor.cpp:47
>      ASSERT(!cursorMap().contains(m_info.identifier()));

This needs to be after the lock.

> Source/WebCore/Modules/indexeddb/server/MemoryCursor.cpp:56
>      ASSERT(cursorMap().contains(m_info.identifier()));

ditto.
Comment 4 Radar WebKit Bug Importer 2021-06-15 23:39:19 PDT
<rdar://problem/79381931>
Comment 5 Sihui Liu 2021-06-16 11:44:31 PDT
Created attachment 431576 [details]
Patch for landing
Comment 6 EWS 2021-06-16 12:12:13 PDT
Committed r278948 (238877@main): <https://commits.webkit.org/238877@main>

All reviewed patches have been landed. Closing bug and clearing flags on attachment 431576 [details].